// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from radar_msgs:msg/RadarReturn.idl
// generated code does not contain a copyright notice

#include "radar_msgs/msg/detail/radar_return__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_radar_msgs
const rosidl_type_hash_t *
radar_msgs__msg__RadarReturn__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xd2, 0xfa, 0xa1, 0x85, 0xf2, 0x2c, 0x2c, 0xf5,
      0x78, 0xcf, 0x2d, 0xfd, 0x69, 0xe0, 0x5c, 0xe6,
      0x26, 0x2d, 0x1a, 0x71, 0x6f, 0x2f, 0xd3, 0xea,
      0x21, 0x9e, 0x9d, 0xb3, 0x1e, 0x1e, 0xd2, 0xf0,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char radar_msgs__msg__RadarReturn__TYPE_NAME[] = "radar_msgs/msg/RadarReturn";

// Define type names, field names, and default values
static char radar_msgs__msg__RadarReturn__FIELD_NAME__range[] = "range";
static char radar_msgs__msg__RadarReturn__FIELD_NAME__azimuth[] = "azimuth";
static char radar_msgs__msg__RadarReturn__FIELD_NAME__elevation[] = "elevation";
static char radar_msgs__msg__RadarReturn__FIELD_NAME__doppler_velocity[] = "doppler_velocity";
static char radar_msgs__msg__RadarReturn__FIELD_NAME__amplitude[] = "amplitude";

static rosidl_runtime_c__type_description__Field radar_msgs__msg__RadarReturn__FIELDS[] = {
  {
    {radar_msgs__msg__RadarReturn__FIELD_NAME__range, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {radar_msgs__msg__RadarReturn__FIELD_NAME__azimuth, 7, 7},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {radar_msgs__msg__RadarReturn__FIELD_NAME__elevation, 9, 9},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {radar_msgs__msg__RadarReturn__FIELD_NAME__doppler_velocity, 16, 16},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {radar_msgs__msg__RadarReturn__FIELD_NAME__amplitude, 9, 9},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
radar_msgs__msg__RadarReturn__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {radar_msgs__msg__RadarReturn__TYPE_NAME, 26, 26},
      {radar_msgs__msg__RadarReturn__FIELDS, 5, 5},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# All variables below are relative to the radar's frame of reference.\n"
  "# This message is not meant to be used alone but as part of a stamped or array message.\n"
  "\n"
  "float32 range                            # Distance (m) from the sensor to the detected return.\n"
  "float32 azimuth                          # Angle (in radians) in the azimuth plane between the sensor and the detected return.\n"
  "                                         # Positive angles are anticlockwise from the sensor and negative angles clockwise from the sensor as per REP-0103.\n"
  "float32 elevation                        # Angle (in radians) in the elevation plane between the sensor and the detected return.\n"
  "                                         # Negative angles are below the sensor. For 2D radar, this will be 0.\n"
  "float32 doppler_velocity                 # The doppler speed (m/s) of the return.\n"
  "float32 amplitude                        # The amplitude of the return (dB).";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
radar_msgs__msg__RadarReturn__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {radar_msgs__msg__RadarReturn__TYPE_NAME, 26, 26},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 937, 937},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
radar_msgs__msg__RadarReturn__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *radar_msgs__msg__RadarReturn__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
